Attribute VB_Name = "Id3GrabModule"
Option Explicit
 
Public Type Tag
    COMM As String
    TPE1 As String
    TIT2 As String
    TRCK As String
    TYER As String
    TALB As String
    TCON As String
End Type

Public ID3Tag As Tag

    
Public Sub GetTags(FilePathName As String)
Dim CommLoc As Integer
Dim Tpe1Loc As Integer
Dim Tit2Loc As Integer
Dim TrckLoc As Integer
Dim TyerLoc As Integer
Dim TalbLoc As Integer
Dim TconLoc As Integer
Dim CommLen As Integer
Dim Tpe1Len As Integer
Dim Tit2Len As Integer
Dim TrckLen As Integer
Dim TyerLen As Integer
Dim TalbLen As Integer
Dim TconLen As Integer
Dim ID3TagLength As Integer
Dim HeaderString As String * 10
Dim ID3TagWhole
Dim TagAsBytes() As Byte
Dim TagParser() As Byte
Dim intIdx

    With ID3Tag
        .COMM = ""
        .TALB = ""
        .TCON = ""
        .TIT2 = ""
        .TPE1 = ""
        .TRCK = ""
        .TYER = ""
    End With

'grab header
    Open FilePathName For Binary As #1
    Get #1, , HeaderString
    Close #1

'not a valid id3v2 tag
    If Left(HeaderString, 3) <> "ID3" Then
        MsgBox "This program only works with valid ID3v2 tags so far..." & _
         vbCrLf, , "And only somewhat at that"
        Exit Sub
    End If

'calculate tag length grabbed from four bytes in header
    ID3TagLength = Asc(Mid(HeaderString, 7, 1)) * 2 ^ 21 + _
     Asc(Mid(HeaderString, 8, 1)) * 2 ^ 14 + _
     Asc(Mid(HeaderString, 9, 1)) * 2 ^ 7 + _
     Asc(Mid(HeaderString, 10, 1)) * 2 ^ 0

'read tag as byte values
    Open FilePathName For Binary As #1
    ReDim TagAsBytes(ID3TagLength) As Byte
    Get #1, , TagAsBytes
    Close #1

'convert tag to unicode
    ID3TagWhole = StrConv(TagAsBytes, vbUnicode)

'get locations of all currently grabbed frames
    Tpe1Loc = InStr(11, ID3TagWhole, "TPE1" & String(3, 0))
    Tpe1Len = Asc(Mid(ID3TagWhole, Tpe1Loc + 7, 1)) - 1
    Tit2Loc = InStr(11, ID3TagWhole, "TIT2" & String(3, 0))
    Tit2Len = Asc(Mid(ID3TagWhole, Tit2Loc + 7, 1)) - 1
    TalbLoc = InStr(11, ID3TagWhole, "TALB" & String(3, 0))
    TalbLen = Asc(Mid(ID3TagWhole, TalbLoc + 7, 1)) - 1
    TrckLoc = InStr(11, ID3TagWhole, "TRCK" & String(3, 0))
    TrckLen = Asc(Mid(ID3TagWhole, TrckLoc + 7, 1)) - 1
    TyerLoc = InStr(11, ID3TagWhole, "TYER" & String(3, 0))
    TyerLen = Asc(Mid(ID3TagWhole, TyerLoc + 7, 1)) - 1
    CommLoc = InStr(11, ID3TagWhole, "COMM" & String(3, 0))
    CommLen = Asc(Mid(ID3TagWhole, CommLoc + 7, 1)) - 1
    TconLoc = InStr(11, ID3TagWhole, "TCON" & String(3, 0))
    TconLen = Asc(Mid(ID3TagWhole, TconLoc + 7, 1)) - 1


'heres where it gets tricky
'lots of busy work to be sure only the text of the tag is grabbed
    With ID3Tag
        If Tpe1Loc <> 0 Then
            If InStr(Mid(ID3TagWhole, Tpe1Loc + 7, Tpe1Len), Chr(&H0)) = 0 Then
                .TPE1 = Mid(ID3TagWhole, Tpe1Loc + 11, Tpe1Len)
            Else
                ReDim TagParser(Tpe1Len) As Byte
                For intIdx = 0 To Tpe1Len
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, Tpe1Loc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TPE1 = .TPE1 & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
        If Tit2Loc <> 0 Then
                    If InStr(Mid(ID3TagWhole, Tit2Loc + 7, Tit2Len), Chr(&H0)) = 0 Then
                .TIT2 = Mid(ID3TagWhole, Tit2Loc + 11, Tit2Len)
            Else
                ReDim TagParser(Tit2Len) As Byte
                For intIdx = 0 To Tit2Len
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, Tit2Loc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TIT2 = .TIT2 & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
        If TalbLoc <> 0 Then
            If InStr(Mid(ID3TagWhole, TalbLoc + 7, TalbLen), Chr(&H0)) = 0 Then
                .TALB = Mid(ID3TagWhole, TalbLoc + 11, TalbLen)
            Else
                ReDim TagParser(TalbLen) As Byte
                For intIdx = 0 To TalbLen
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, TalbLoc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TALB = .TALB & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
        If TrckLoc <> 0 Then
                    If InStr(Mid(ID3TagWhole, TrckLoc + 7, TrckLen), Chr(&H0)) = 0 Then
                .TRCK = Mid(ID3TagWhole, TrckLoc + 11, TrckLen)
            Else
                ReDim TagParser(TrckLen) As Byte
                For intIdx = 0 To TrckLen
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, TrckLoc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TRCK = .TRCK & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
        If TyerLoc <> 0 Then
            If InStr(Mid(ID3TagWhole, TyerLoc + 7, TyerLen), Chr(&H0)) = 0 Then
                .TYER = Mid(ID3TagWhole, TyerLoc + 11, TyerLen)
            Else
                ReDim TagParser(TyerLen) As Byte
                For intIdx = 0 To TyerLen
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, TyerLoc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TYER = .TYER & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
        If CommLoc <> 0 Then
'comments are different, they have three bytes that tell the language
'those bytes are ignored at this point in time
            If InStr(Mid(ID3TagWhole, CommLoc + 7, CommLen), Chr(&H0)) = 0 Then
                .COMM = Mid(ID3TagWhole, CommLoc + 15, CommLen - 4)
            Else
                ReDim TagParser(CommLen) As Byte
                For intIdx = 0 To CommLen
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, CommLoc + 14 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser) - 4
                    If TagParser(intIdx) <> 0 Then
                        .COMM = .COMM & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If

        If TconLoc <> 0 Then
            If InStr(Mid(ID3TagWhole, TconLoc + 7, TconLen), Chr(&H0)) = 0 Then
                .TCON = Mid(ID3TagWhole, TconLoc + 11, TconLen)
            Else
                ReDim TagParser(TconLen) As Byte
                For intIdx = 0 To TconLen
                    TagParser(intIdx) = Asc(Mid(ID3TagWhole, TconLoc + 10 + intIdx, 1))
                Next intIdx
                For intIdx = 1 To UBound(TagParser)
                    If TagParser(intIdx) <> 0 Then
                        .TCON = .TCON & Chr(TagParser(intIdx))
                    End If
                Next intIdx
            End If
        End If
    End With

'in case TCON field has value from id3v1
'very ugly, ill clean it later
    If Left(ID3Tag.TCON, 1) = "(" And Right(ID3Tag.TCON, 1) = ")" Then
        Select Case Mid(ID3Tag.TCON, 2, Len(ID3Tag.TCON) - 2)
            Case 0
                ID3Tag.TCON = "Blues"
            Case 1
                ID3Tag.TCON = "Classic Rock"
            Case 2
                ID3Tag.TCON = "Country"
            Case 3
                ID3Tag.TCON = "Dance"
            Case 4
                ID3Tag.TCON = "Disco"
            Case 5
                ID3Tag.TCON = "Funk"
            Case 6
                ID3Tag.TCON = "Grunge"
            Case 7
                ID3Tag.TCON = "Hip-Hop"
            Case 8
                ID3Tag.TCON = "Jazz"
            Case 9
                ID3Tag.TCON = "Metal"
            Case 10
                ID3Tag.TCON = "New Age"
            Case 11
                ID3Tag.TCON = "Oldies"
            Case 12
                ID3Tag.TCON = "Other"
            Case 13
                ID3Tag.TCON = "Pop"
            Case 14
                ID3Tag.TCON = "R&B"
            Case 15
                ID3Tag.TCON = "Rap"
            Case 16
                ID3Tag.TCON = "Reggae"
            Case 17
                ID3Tag.TCON = "Rock"
            Case 18
                ID3Tag.TCON = "Techno"
            Case 19
                ID3Tag.TCON = "Industrial"
            Case 20
                ID3Tag.TCON = "Alternative"
            Case 21
                ID3Tag.TCON = "Ska"
            Case 22
                ID3Tag.TCON = "Death Metal"
            Case 23
                ID3Tag.TCON = "Pranks"
            Case 24
                ID3Tag.TCON = "Soundtrack"
            Case 25
                ID3Tag.TCON = "Euro-Techno"
            Case 26
                ID3Tag.TCON = "Ambient"
            Case 27
                ID3Tag.TCON = "Trip-Hop"
            Case 28
                ID3Tag.TCON = "Vocal"
            Case 29
                ID3Tag.TCON = "Jazz Funk"
            Case 30
                ID3Tag.TCON = "Fusion"
            Case 31
                ID3Tag.TCON = "Trance"
            Case 32
                ID3Tag.TCON = "Classical"
            Case 33
                ID3Tag.TCON = "Instrumental"
            Case 34
                ID3Tag.TCON = "Acid"
            Case 35
                ID3Tag.TCON = "House"
            Case 36
                ID3Tag.TCON = "Game"
            Case 37
                ID3Tag.TCON = "Sound Clip"
            Case 38
                ID3Tag.TCON = "Gospel"
            Case 39
                ID3Tag.TCON = "Noise"
            Case 40
                ID3Tag.TCON = "AlternRock"
            Case 41
                ID3Tag.TCON = "Bass"
            Case 42
                ID3Tag.TCON = "Soul"
            Case 43
                ID3Tag.TCON = "Punk"
            Case 44
                ID3Tag.TCON = "Space"
            Case 45
                ID3Tag.TCON = "Meditative"
            Case 46
                ID3Tag.TCON = "Instrumental Pop"
            Case 47
                ID3Tag.TCON = "Instrumental Rock"
            Case 48
                ID3Tag.TCON = "Ethnic"
            Case 49
                ID3Tag.TCON = "Gothic"
            Case 50
                ID3Tag.TCON = "Darkwave"
            Case 51
                ID3Tag.TCON = "Techno-Industrial"
            Case 52
                ID3Tag.TCON = "Electronic"
            Case 53
                ID3Tag.TCON = "Eurodance"
            Case 54
                ID3Tag.TCON = "Eurodance"
            Case 55
                ID3Tag.TCON = "Dream"
            Case 56
                ID3Tag.TCON = "Southern Rock"
            Case 57
                ID3Tag.TCON = "Comedy"
            Case 58
                ID3Tag.TCON = "Cult"
            Case 59
                ID3Tag.TCON = "Gangsta"
            Case 60
                ID3Tag.TCON = "Top 40"
            Case 61
                ID3Tag.TCON = "Christian Rap"
            Case 62
                ID3Tag.TCON = "Pop/Funk"
            Case 63
                ID3Tag.TCON = "Jungle"
            Case 64
                ID3Tag.TCON = "Native American"
            Case 65
                ID3Tag.TCON = "Cabaret"
            Case 66
                ID3Tag.TCON = "New Wave"
            Case 67
                ID3Tag.TCON = "Psychadelic"
            Case 68
                ID3Tag.TCON = "Rave"
            Case 69
                ID3Tag.TCON = "Showtunes"
            Case 70
                ID3Tag.TCON = "Trailer"
            Case 71
                ID3Tag.TCON = "Lo-Fi"
            Case 72
                ID3Tag.TCON = "Tribal"
            Case 73
                ID3Tag.TCON = "Acid Punk"
            Case 74
                ID3Tag.TCON = "Acid Jazz"
            Case 75
                ID3Tag.TCON = "Polka"
            Case 76
                ID3Tag.TCON = "Retro"
            Case 77
                ID3Tag.TCON = "Musical"
            Case 78
                ID3Tag.TCON = "Rock & Roll"
            Case 79
                ID3Tag.TCON = "Hard Rock"
        End Select
    End If

End Sub